"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runBuilder = void 0;
const architect_1 = require("@angular-devkit/architect");
const static_injector_1 = require("static-injector");
const webpack = __importStar(require("webpack"));
const webpack_configuration_change_service_1 = require("../application/webpack-configuration-change.service");
const platform_1 = require("../platform");
const index_origin_1 = require("./index.origin");
exports.default = (0, architect_1.createBuilder)((angularOptions, context) => {
    return runBuilder(angularOptions, context);
});
function runBuilder(angularOptions, context) {
    return (0, index_origin_1.execute)(angularOptions, context, {
        webpackConfiguration: (options) => __awaiter(this, void 0, void 0, function* () {
            const injector = static_injector_1.Injector.create({
                providers: [
                    ...(0, platform_1.getBuildPlatformInjectConfig)(platform_1.PlatformType.wx),
                    {
                        provide: webpack_configuration_change_service_1.WebpackConfigurationChangeService,
                        useFactory: (injector) => {
                            return new webpack_configuration_change_service_1.WebpackConfigurationChangeService(angularOptions, context, options, injector);
                        },
                        deps: [static_injector_1.Injector],
                    },
                ],
            });
            const config = injector.get(webpack_configuration_change_service_1.WebpackConfigurationChangeService);
            config.init();
            yield config.change();
            const buildPlatform = injector.get(platform_1.BuildPlatform);
            options.plugins.push(new webpack.DefinePlugin({
                describe: `${buildPlatform.globalVariablePrefix}.describe`,
                xdescribe: `${buildPlatform.globalVariablePrefix}.xdescribe`,
                fdescribe: `${buildPlatform.globalVariablePrefix}.fdescribe`,
                it: `${buildPlatform.globalVariablePrefix}.it`,
                xit: `${buildPlatform.globalVariablePrefix}.xit`,
                fit: `${buildPlatform.globalVariablePrefix}.fit`,
                beforeEach: `${buildPlatform.globalVariablePrefix}.beforeEach`,
                afterEach: `${buildPlatform.globalVariablePrefix}.afterEach`,
                beforeAll: `${buildPlatform.globalVariablePrefix}.beforeAll`,
                afterAll: `${buildPlatform.globalVariablePrefix}.afterAll`,
                setSpecProperty: `${buildPlatform.globalVariablePrefix}.setSpecProperty`,
                setSuiteProperty: `${buildPlatform.globalVariablePrefix}.setSuiteProperty`,
                expect: `${buildPlatform.globalVariablePrefix}.expect`,
                expectAsync: `${buildPlatform.globalVariablePrefix}.expectAsync`,
                pending: `${buildPlatform.globalVariablePrefix}.pending`,
                fail: `${buildPlatform.globalVariablePrefix}.fail`,
                spyOn: `${buildPlatform.globalVariablePrefix}.spyOn`,
                spyOnProperty: `${buildPlatform.globalVariablePrefix}.spyOnProperty`,
                spyOnAllFunctions: `${buildPlatform.globalVariablePrefix}.spyOnAllFunctions`,
                jsApiReporter: `${buildPlatform.globalVariablePrefix}.jsApiReporter`,
                jasmine: `${buildPlatform.globalVariablePrefix}.jasmine`,
            }));
            options.output.path += '/dist';
            return options;
        }),
    });
}
exports.runBuilder = runBuilder;
