import { BuiltInControlValueAccessor, ControlValueAccessor } from './control_value_accessor';
import * as i0 from "@angular/core";
export declare const SWITCH_VALUE_ACCESSOR: any;
/**
 * @description
 * The `ControlValueAccessor` for writing a number value and listening to number input changes.
 * The value accessor is used by the `FormControlDirective`, `FormControlName`, and `NgModel`
 * directives.
 *
 * @usageNotes
 *
 * ### Using a number input with a reactive form.
 *
 * The following example shows how to use a number input with a reactive form.
 *
 * ```ts
 * const totalCountControl = new FormControl();
 * ```
 *
 * ```
 * <input type="number" [formControl]="totalCountControl">
 * ```
 *
 * @ngModule ReactiveFormsModule
 * @ngModule FormsModule
 * @publicApi
 */
export declare class PickerValueAccessor extends BuiltInControlValueAccessor implements ControlValueAccessor {
    value: number | any[] | string | undefined;
    disabled: boolean | undefined;
    /**
     * Sets the "value" property on the input element.
     * @nodoc
     */
    writeValue(value: number | any[] | string): void;
    valueChange(value: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<PickerValueAccessor, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<PickerValueAccessor, "picker[formControlName],picker[formControl],picker[ngModel]", never, {}, {}, never, never, false, never>;
}



declare const PickerValueAccessor_Listeners:["bindchange"];
declare const PickerValueAccessor_Properties:["value","disabled"];